/*
 *  TimeEdit.cs
 *  Copyright (C) 2004-2005 Marcin Krystian Krzywonos
 *  License: GNU/GPL, version 2
 */


/*
 * TO CHANGE:
 * 1. Gtk.Combo IS OBSOLETE !
 */


using System;
using GLib;
using gnutu;


namespace gnutu.Widgets {
	public class TimeEdit : Gtk.HBox {
		public Gtk.SpinButton Hour;
		public Gtk.SpinButton Minutes;
		public Gtk.Combo      Switcher;
		
		
		public TimeEdit ()
		{
			// Settings
			this.Spacing = 3;
			
			// Hour
			if (gnutu.Settings.GetBool ("TimeMode24") == true) { 
				Hour = new Gtk.SpinButton (0, 23, 1);
				Hour.Value = gnutu.Settings.SchoolBeginTime24;
			} else {
				Hour = new Gtk.SpinButton (1, 12, 1);
				Hour.Value = gnutu.Settings.SchoolBeginTime;
			}
			
			Hour.WidthRequest = 40;
			this.Add (Hour);
			
			
			// Minutes
			Minutes = new Gtk.SpinButton (0, 59, 5);
			Minutes.WidthRequest = 40;
			this.Add (Minutes);
			
			
			// Time switcher
			if (gnutu.Settings.GetBool ("TimeMode24") == false) {
				Switcher = new Gtk.Combo ();
				Switcher.PopdownStrings = new string [] {"A.M.", "P.M."};
				Switcher.Entry.Editable = false;
				Switcher.WidthRequest = 60;
				
				this.Add (Switcher);
			}
		}
		
		
		public void SetTime (string time)
		{
			if (time.Length > 5) {
				string [] tmp1 = time.Split (' ');
				
				string [] tmp2 = tmp1[0].Split (':');
				Hour.Value = System.Convert.ToDouble (tmp2 [0]);
				Minutes.Value = System.Convert.ToDouble (tmp2 [1]);
				
				Switcher.Entry.Text = tmp1 [1];
			} else {
				string [] tmp = time.Split (':');
				Hour.Value = System.Convert.ToDouble (tmp [0]);
				Minutes.Value = System.Convert.ToDouble (tmp [1]);
			}
		}
		
		
		public string GetText ()
		{
			string hour    = Hour.Value.ToString ();
			string minutes = Minutes.Value.ToString ();
			
			if (Hour.Value <= 9)
				hour = "0" + hour;
				
			if (Minutes.Value <= 9)
				minutes = "0" + minutes;
				
			
			if (gnutu.Settings.GetBool ("TimeMode24") == true)
				return hour + ":" + minutes;
			else
				return hour + ":" + minutes + " " + Switcher.Entry.Text;

		}
	}
}
